import { __decorate } from 'tslib';
import { Pipe, NgModule } from '@angular/core';

let SearchByPipe = class SearchByPipe {
    constructor() {
        this.array = [];
        this.skips = [];
    }
    transform(value, searchWord, propertiesForSearch, sensitive = true) {
        if (searchWord) {
            this.initArrays();
            if (searchWord !== '' && searchWord !== null) {
                propertiesForSearch.map((property) => {
                    value.map((val, index) => {
                        if (this.skips.indexOf(index) === -1) {
                            const result = this.searchInByString(val, property);
                            if (result) {
                                if (sensitive) {
                                    if (result.toLowerCase().indexOf(searchWord.toLowerCase()) > -1) {
                                        this.addItems(val, index);
                                    }
                                }
                                else {
                                    if (result.indexOf(searchWord.toLowerCase()) > -1) {
                                        this.addItems(val, index);
                                    }
                                }
                            }
                        }
                    });
                });
                return this.array;
            }
        }
        return value;
    }
    initArrays() {
        this.array = [];
        this.skips = [];
    }
    addItems(val, index) {
        this.array.push(val);
        this.skips.push(index);
    }
    searchInByString(obj = {}, properties, value) {
        const keys = properties.split('.');
        if (value) {
            return value;
        }
        else {
            const type = typeof obj[keys[0]];
            if (type === 'string' || type === 'number' || type === 'boolean') {
                value = obj[keys[0]];
                return this.searchInByString({}, '', value);
            }
            if (type === 'object') {
                let newObj = {};
                newObj = Object.assign(newObj, obj[keys[0]]);
                keys.splice(0, 1);
                const newProperties = keys.join('.');
                return this.searchInByString(newObj, newProperties);
            }
        }
    }
};
SearchByPipe = __decorate([
    Pipe({
        name: 'searchBy'
    })
], SearchByPipe);

let PipeSearchByModule = class PipeSearchByModule {
};
PipeSearchByModule = __decorate([
    NgModule({
        declarations: [SearchByPipe],
        imports: [],
        exports: [SearchByPipe]
    })
], PipeSearchByModule);

/*
 * Public API Surface of search-by
 */

/**
 * Generated bundle index. Do not edit.
 */

export { PipeSearchByModule, SearchByPipe as ɵa };
//# sourceMappingURL=ngx-pipe-search-by.js.map
