import { __decorate } from 'tslib';
import { Pipe, NgModule } from '@angular/core';

var SearchByPipe = /** @class */ (function () {
    function SearchByPipe() {
        this.array = [];
        this.skips = [];
    }
    SearchByPipe.prototype.transform = function (value, searchWord, propertiesForSearch, sensitive) {
        var _this = this;
        if (sensitive === void 0) { sensitive = true; }
        if (searchWord) {
            this.initArrays();
            if (searchWord !== '' && searchWord !== null) {
                propertiesForSearch.map(function (property) {
                    value.map(function (val, index) {
                        if (_this.skips.indexOf(index) === -1) {
                            var result = _this.searchInByString(val, property);
                            if (result) {
                                if (sensitive) {
                                    if (result.toLowerCase().indexOf(searchWord.toLowerCase()) > -1) {
                                        _this.addItems(val, index);
                                    }
                                }
                                else {
                                    if (result.indexOf(searchWord.toLowerCase()) > -1) {
                                        _this.addItems(val, index);
                                    }
                                }
                            }
                        }
                    });
                });
                return this.array;
            }
        }
        return value;
    };
    SearchByPipe.prototype.initArrays = function () {
        this.array = [];
        this.skips = [];
    };
    SearchByPipe.prototype.addItems = function (val, index) {
        this.array.push(val);
        this.skips.push(index);
    };
    SearchByPipe.prototype.searchInByString = function (obj, properties, value) {
        if (obj === void 0) { obj = {}; }
        var keys = properties.split('.');
        if (value) {
            return value;
        }
        else {
            var type = typeof obj[keys[0]];
            if (type === 'string' || type === 'number' || type === 'boolean') {
                value = obj[keys[0]];
                return this.searchInByString({}, '', value);
            }
            if (type === 'object') {
                var newObj = {};
                newObj = Object.assign(newObj, obj[keys[0]]);
                keys.splice(0, 1);
                var newProperties = keys.join('.');
                return this.searchInByString(newObj, newProperties);
            }
        }
    };
    SearchByPipe = __decorate([
        Pipe({
            name: 'searchBy'
        })
    ], SearchByPipe);
    return SearchByPipe;
}());

var PipeSearchByModule = /** @class */ (function () {
    function PipeSearchByModule() {
    }
    PipeSearchByModule = __decorate([
        NgModule({
            declarations: [SearchByPipe],
            imports: [],
            exports: [SearchByPipe]
        })
    ], PipeSearchByModule);
    return PipeSearchByModule;
}());

/*
 * Public API Surface of search-by
 */

/**
 * Generated bundle index. Do not edit.
 */

export { PipeSearchByModule, SearchByPipe as ɵa };
//# sourceMappingURL=ngx-pipe-search-by.js.map
